#include <Adafruit_GFX.h>
#include <gfxfont.h>
#include <Adafruit_ILI9341.h>
#include "SPI.h"
#define TFT_DC A3
#define TFT_CS 10 // Change this to pin 10 in new design
#define TFT_RST  A2  // Reset line for TFT (or connect to +5V)
#define TFT_MOSI 11
#define TFT_MISO 12
#define TFT_CLK 13
Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_RST);

const int slaveSelectPinA = 7; // LE for the VGA Rx.
const int slaveSelectPinB = 6; // LE for the VGA Tx.

const int QPL9065VPD_A = 3;
const int QPL9065VBYP_A = 2;
const int QPL9065VPD_B = 4;
const int QPL9065VBYP_B = 5;

int sliderPinChannelA = A4;    // select the input pin for the potentiometer for control of channel A Rx
int sliderPinChannelB = A5;     // select the input pin for the potentiometer for control of channel B Tx

int LED1 = 12;
int LED2 = 9;
int LED3 = 8;
int RSSIEnable = A0;
int TxPower =1000;
int maxTxPower =1000;
int previousMaxTxPower =1000;
unsigned long previousMillis = 0;
int interval = 2000;
int x=0;
float y=0.001;
int decibels= -1000;
int maxDecibels= -1000;

float adjustedSensorValueA =0.01;
float adjustedSensorValueB =0.01;

int sensorValueA = 0;
int sensorValueB = 0;
long rabbits;
unsigned long previousMillisA = 0;
unsigned long previousMillisB = 0;
int intervalA = 1000;  
int intervalB = 1000; 
int ledStateA = LOW;
int ledStateB = LOW;

void setup() 
{
  Serial.begin(9600);
  tft.begin();
  tft.setRotation(1);
  tft.fillScreen(ILI9341_BLACK);
  Serial.println("Test Begin!");
  delay(500);  
  // set the slaveSelectPinA as an output:
  pinMode(slaveSelectPinA, OUTPUT);
  pinMode(slaveSelectPinB, OUTPUT);
  pinMode(QPL9065VPD_A, OUTPUT);
  pinMode(QPL9065VBYP_A, OUTPUT);
  pinMode(QPL9065VPD_B, OUTPUT);
  pinMode(QPL9065VBYP_B, OUTPUT);
  
  pinMode(LED1, OUTPUT);
  pinMode(LED2, OUTPUT);
  pinMode(LED3, OUTPUT);
  pinMode(RSSIEnable, OUTPUT);
  digitalWrite(RSSIEnable,HIGH);
      
        digitalWrite(QPL9065VPD_A, LOW);
        digitalWrite(QPL9065VBYP_A, HIGH);
        Serial.println("LOW,HIGH ...... Channel A Low power");
        
//  digitalWrite(QPL9065VPD_B, HIGH);
//  digitalWrite(QPL9065VBYP_B, LOW);
  
// Set QPL9065VPD_A to HIGH and QPL9065VBYP_A to LOW to disable them both and disable bypass.
//  digitalWrite(QPL9065VPD_A, HIGH);
//  digitalWrite(QPL9065VBYP_A, LOW);
// Set QPL9065VPD_B to HIGH and QPL9065VBYP_B to LOW to disable them both and disable bypass.

  
  sensorValueA = analogRead(sliderPinChannelA);
  Serial.print("Sensor value channel A:");Serial.println(sensorValueA);
//  sensorValueB = analogRead(sliderPinChannelB);
//  Serial.print("Sensor value channel B:");Serial.println(sensorValueB);
  introText();
  delay(1000);
  rectangle1();
  staticText();
}
void loop(void) 
{ 
  TxPower = analogRead(A1);
//  Serial.print("TxPower:         ");Serial.println(TxPower);
  TFTReadings();

 //  readSliderA();
 //  readSliderB();
  
//   delay(2000);
   writeSPItoChannelA();
//   writeSPItoChannelB();
//   Serial.println("");

}
void readSliderA()
{
    sensorValueA = analogRead(sliderPinChannelA);
    Serial.print("Sensor value channel A:");Serial.println(sensorValueA);
    if(sensorValueA<2)
    {
        digitalWrite(QPL9065VPD_A, HIGH);
        digitalWrite(QPL9065VBYP_A, HIGH);
        Serial.println("HIGH,HIGH ....... Channel A Everything is OFF");
    }
    if((sensorValueA>1)&&(sensorValueA<513))
    {
        digitalWrite(QPL9065VPD_A, LOW);
        digitalWrite(QPL9065VBYP_A, HIGH);
        Serial.println("LOW,HIGH ...... Channel A Low power");

    }
    if(sensorValueA>512)
    {
        digitalWrite(QPL9065VPD_A, LOW);
        digitalWrite(QPL9065VBYP_A, LOW);
        Serial.println("LOW,LOW ...... Channel A High power");
    }
}
void readSliderB()
{
    sensorValueB = analogRead(sliderPinChannelB);
    Serial.print("Sensor value channel B:");Serial.println(sensorValueB);
    if(sensorValueB<2)
    {
        digitalWrite(QPL9065VPD_B, HIGH);
        digitalWrite(QPL9065VBYP_B, HIGH);
        Serial.println("HIGH,HIGH ....... Channel B Everything is OFF");
        //interval=10000;
    }
    if((sensorValueB>1)&&(sensorValueB<513))
    {
        digitalWrite(QPL9065VPD_B, LOW);
        digitalWrite(QPL9065VBYP_B, HIGH);
        Serial.println("LOW,HIGH ...... Channel B Low power");
        //interval=1000;
    }
    if(sensorValueB>512)
    {
        digitalWrite(QPL9065VPD_B, LOW);
        digitalWrite(QPL9065VBYP_B, LOW);
        Serial.println("LOW,LOW ...... Channel B High power");
        //interval=100;
    }
}
void writeSPItoChannelA()
{
  sensorValueA = analogRead(sliderPinChannelA);
  adjustedSensorValueA = sensorValueA*0.0616;
  rabbits = adjustedSensorValueA;
//  Serial.print("Sensor Value A:  ");  Serial.println(sensorValueA);
//  Serial.print("Adjusted Sensor Value A:  ");  Serial.println(adjustedSensorValueA,2);
//  Serial.print("Rabbits:  ");  Serial.println(rabbits);
  SPI.begin();
  digitalWrite(slaveSelectPinA, LOW);
  SPI.transfer(rabbits);
  digitalWrite(slaveSelectPinA, HIGH);
  SPI.end();
  intervalA=1024-sensorValueA;
//  Serial.print("intervalA:    ");Serial.println(intervalA);
}  
void writeSPItoChannelB()
{
  sensorValueB = analogRead(sliderPinChannelB);
  adjustedSensorValueB = sensorValueB*63/1023.00;
  rabbits = adjustedSensorValueB;
  Serial.print("Sensor Value B:  ");  Serial.println(sensorValueB);
  Serial.print("Adjusted Sensor Value B:  ");  Serial.println(adjustedSensorValueB,2);
  Serial.print("Rabbits B:  ");  Serial.println(rabbits);
  SPI.begin();
  digitalWrite(slaveSelectPinB, LOW);
  SPI.transfer(rabbits);
  digitalWrite(slaveSelectPinB, HIGH);
  SPI.end();
  intervalB=1024-sensorValueB;
  Serial.print("intervalB:    ");Serial.println(intervalB);
}  
void rectangle1 ()
{
          tft.fillRect(0, 35, 320, 90, ILI9341_RED);
          // x,y,(from top left corner)w,h
}
void rectangle4 ()
{
          tft.fillRect(190, 35, 65, 90, ILI9341_BLUE);
          // x,y,(from top left corner)w,h
}
void rectangle5 ()
{
          tft.fillRect(190, 35, 130, 90, ILI9341_BLUE);
          // x,y,(from top left corner)w,h
}
void rectangle3 ()
{
          tft.fillRect(0, 180, 320, 85, ILI9341_RED);
          // x,y,(from top left corner)w,h
}

void staticText ()
{
  rectangle5 ();
  tft.setTextColor(ILI9341_GREEN);
  tft.setTextSize(3);  
  tft.setCursor(10, 40);
  tft.println("Frequency:");
  tft.setCursor(10, 70);
  tft.println("RSSI:");
  tft.setCursor(10, 100);  
  tft.println("Max RSSI:"); 
  tft.setCursor(20, 0);
  tft.println("   4G REPEATER");
  rectangle3 ();
  tft.setCursor(20, 155);
  tft.println("    VERIZON");
  tft.setCursor(20, 185);
  tft.setTextColor(ILI9341_GREEN);
  tft.println("Rx: 746-756 MHz");
  tft.setCursor(20, 215);
  tft.println("Tx: 777-787 MHz");
}
void TFTReadings ()
{
  unsigned long currentMillis = millis();
  if(TxPower<maxTxPower)
  {
    maxTxPower = TxPower;
  }

// This allows the main loop to run as fast as possible without causing TFT screen to flicker too much:
  if (currentMillis - previousMillis >= interval) 
  { 
    convertToDecibels(); 
    rectangle4();
    tft.setTextColor(ILI9341_GREEN);
    tft.setTextSize(3);
    tft.setCursor(200, 40);
    tft.println("782");
    tft.setCursor(260, 40);
    tft.println("MHz"); 
    tft.setCursor(200, 70);
    tft.println(decibels);
    tft.setCursor(260, 70);
    tft.println("dBm");       
    tft.setCursor(200, 100);
    tft.println(maxDecibels);
    tft.setCursor(260, 100);
    tft.println("dBm");
    previousMillis = currentMillis;
  }
}
void convertToDecibels()
  {
    y=maxTxPower*5.0/1024;
//    Serial.print("Y:  ");  Serial.println(y);
    
    interpolate();
                    
//    Serial.print("X:  ");  Serial.println(x);
    maxDecibels = x;
//    Serial.print("Max Decibels:  ");  Serial.println(maxDecibels);
    y=TxPower*5.0/1024;
//    Serial.print("Y:  ");  Serial.println(y);
    
    interpolate();
                    
//    Serial.print("X:  ");  Serial.println(x);
    decibels = x;
//    Serial.print("Decibels:  ");  Serial.println(decibels);
  }
void introText()
{
  tft.setTextColor(ILI9341_GREEN);
  tft.setTextSize(3);
  tft.setCursor(110, 70);  
  tft.println("HELLO");
}
void interpolate()
{
    if((y>2.0)&&(y<=2.1)){x=-65;}
    if((y>1.9)&&(y<=2.0)){x=-60;}
    if((y>1.8)&&(y<=1.9)){x=-55;}
    if((y>1.7)&&(y<=1.8)){x=-50;}
    if((y>1.6)&&(y<=1.7)){x=-45;}
    if((y>1.4)&&(y<=1.6)){x=-40;}
    if((y>1.3)&&(y<=1.4)){x=-35;}
    if((y>1.2)&&(y<=1.3)){x=-30;}
    if((y>1.1)&&(y<=1.2)){x=-25;}
    if((y>1.0)&&(y<=1.1)){x=-20;}
    if((y>0.8)&&(y<=1.0)){x=-15;}
    if((y>0.7)&&(y<=0.8)){x=-10;}
    if((y>0.65)&&(y<=0.7)){x=-5;}
    if((y>0.57)&&(y<=0.65)){x=0;}
    if((y>0.54)&&(y<=0.57)){x=5;}
    if((y>0.50)&&(y<=0.54)){x=10;}
    if((y>0.00)&&(y<=0.50)){x=15;}
}






